package ru.dbotthepony.mc.otm.capability.android

import net.minecraft.nbt.CompoundTag
import net.minecraft.world.entity.LivingEntity
import net.minecraft.world.item.ItemStack
import net.minecraftforge.common.util.INBTSerializable
import net.minecraftforge.event.entity.living.LivingHurtEvent
import ru.dbotthepony.mc.otm.android.AndroidFeature
import ru.dbotthepony.mc.otm.android.AndroidFeatureType
import ru.dbotthepony.mc.otm.capability.IMatteryEnergyStorage
import ru.dbotthepony.mc.otm.core.Fraction
import java.util.*

interface IAndroidCapability : IMatteryEnergyStorage, INBTSerializable<CompoundTag?> {
	fun tick()
	fun tickClient()
	fun getEntity(): LivingEntity
	fun <T : AndroidFeature> addFeature(feature: AndroidFeatureType<T>): T
	fun removeFeature(feature: AndroidFeatureType<*>): Boolean
	fun hasFeature(feature: AndroidFeatureType<*>): Boolean
	fun hasFeatureLevel(feature: AndroidFeatureType<*>, level: Int): Boolean

	fun <T : AndroidFeature> getFeature(feature: AndroidFeatureType<T>): T?

	fun <T : AndroidFeature> getFeatureO(feature: AndroidFeatureType<T>): Optional<T> {
		val get = getFeature(feature)
		return if (get != null) Optional.of(get) else Optional.empty()
	}

	fun <T : AndroidFeature> ifFeature(feature: AndroidFeatureType<T>, consumer: (T) -> Unit) {
		val get = getFeature(feature)

		if (get != null) {
			consumer(get)
		}
	}

	fun isAndroid(): Boolean = true

	fun onHurt(event: LivingHurtEvent) {}
	var batteryItemStack: ItemStack
	fun invalidateNetworkState() // tell capability that player forgot everything, and everything needs to be re-networked
	fun setEnergy(value: Fraction)
	fun setMaxEnergy(value: Fraction)
}